<?php
//call the FPDF library
//require('fpdf181/fpdf.php');
$this->load->library('Fpdf_Master');

//$today = date('Y-m-d'));
//A4 width : 219mm
//default margin : 10mm each side
//writable horizontal : 219-(10*2)=189mm

//$tt =  $user;
//class PDF_sample extends FPDF

$data= '';   

class PDF_Rotate extends FPDF
{

}

class PDF_sample extends FPDF {
    
    
  
  	private $data = array();
  	private $inv = array();
  	private $inv_itm = array();
  	private $tm = array();
  	private $options = array(
  		'inv' => '',
  		'destinationfile' => '',
  		'paper_size'=>'F4',
  		'orientation'=>'P'
  	);
  	
  	function __construct($data = array(), $options = array(),$inv = array(),$inv_itm = array(),$tm = array()) {
    	parent::__construct();
    	$this->data = $data;
    	$this->inv = $inv;
    	$this->inv_itm = $inv_itm;
    	$this->options = $options;
    	$this->tm = $tm;
	}
	

	
	function Footer()
{
    // Go to 1.5 cm from bottom
   
    $this->SetY(-15);
    
//	$this->Image('assets/images/meslogo.png',8,10,-300);  //$this->Image('img/cargologo.jpg',15,890,40,40);
//	$this->Image('img/cargologo.jpg',15,540,50,50);
	 
	 //$this->Ln(2);
$this->SetFont('Arial','B',8);
$this->Cell(5 ,-3,'CREATED USER & DATE : ' .$this->inv[0]->ret_cuser.' / '.$this->inv[0]->ret_cdate.' / '.$this->inv[0]->retm_code.$this->inv[0]->retm_id,0,0);//end of line
$this->Cell(5 ,5,$this->inv[0]->ret_euser,0,0);//end of line

   $this->SetFont('Arial','',7);
	 
//	$this->SetX(0); $this->Cell(0, 10, $this->tm[1][0]->pro_fslogans, 0, 0,'C');
//	$this->Ln(2);
//	$this->SetX(0); $this->Cell(0, 12, $this->tm[1][0]->pro_sfslogans, 0, 0,'C');
    // Select Arial italic 8
    $this->SetFont('Arial','',7);
	
    // Print centered page number
    //$this->Cell(0,10,'Page '.$this->PageNo(),0,0,'R');
    $this->Cell(0,10,'Page '.$this->PageNo().' of {nb}',0,0,'R');
     $this->Line(18,283,205,283);
	
}

var $angle=0;

function Rotate($angle,$x=-1,$y=-1)
{
    if($x==-1)
        $x=$this->x;
    if($y==-1)
        $y=$this->y;
    if($this->angle!=0)
        $this->_out('Q');
    $this->angle=$angle;
    if($angle!=0)
    {
        $angle*=M_PI/180;
        $c=cos($angle);
        $s=sin($angle);
        $cx=$x*$this->k;
        $cy=($this->h-$y)*$this->k;
        $this->_out(sprintf('q %.5F %.5F %.5F %.5F %.2F %.2F cm 1 0 0 1 %.2F %.2F cm',$c,$s,-$s,$c,$cx,$cy,-$cx,-$cy));
    }
}

function _endpage()
{
    if($this->angle!=0)
    {
        $this->angle=0;
        $this->_out('Q');
    }
    parent::_endpage();
}




function Header()
{
    

    
    //Put the watermark
    $this->SetFont('Arial','B',50);
    $this->SetTextColor(255,192,203);
    $this->RotatedText(20,260,'INVOICE RETURN NOTE',45);
    
   
    

}

        function RotatedText($x, $y, $txt, $angle)
{
    //Text rotated around its origin
    $this->Rotate($angle,$x,$y);
    $this->Text($x,$y,$txt);
    $this->Rotate(0);
}


	
	public function rptDetailData () {
		
		//
		$border = 0;
		$this->AddPage();
		$this->SetAutoPageBreak(False);
		$this->AliasNbPages();
		$left = 18;
		$left1 = 5;
		//$left = 15;
		
		
	$this->SetLeftMargin($left);

		 // Logo
  //$this->Image('assets/images/nancelogo.png',18,20,-150);
    // Arial bold 15
    $this->SetFont('Arial','B',16);
    // Move to the right
    //$this->Cell(77);
    // Title
    $this->Cell(0,10,$this->tm[1][0]->pro_name,0,0,'C');
     $this->Ln(7);
     
     //$this->Cell(77);
     $this->SetFont('Arial','',10);
    $this->Cell(0,10,$this->tm[1][0]->pro_add,0,0,'C');
   
     
    $this->Ln(4);
     //$this->Cell(77);
     $this->SetFont('Arial','',10);
    $this->Cell(0,10,$this->tm[1][0]->pro_num,0,0,'C');
    
    $this->Ln(4);
     //$this->Cell(77);
     $this->SetFont('Arial','',10);
    $this->Cell(0,10,$this->tm[1][0]->pro_email.' | '.$this->tm[1][0]->pro_web.' | Reg.No: '.$this->tm[1][0]->pro_reg,0,0,'C');
    // $this->Ln(4);
     //$this->Cell(77);
    // $this->SetFont('Arial','',10);
    //$this->Cell(111,10,$this->tm[1][0]->pro_web,0,0,'R');
     //$this->Ln(6);
    
     //$this->Cell(77);
    // $this->SetFont('Arial','B',10);
    //$this->Cell(111,10,"Company Reg.No:".$this->tm[1][0]->pro_reg,0,0,'R');
    // Line break
    $this->Ln(15);
   $this->Line(18,35,205,35); 
   
$this->SetFont('Arial','B',20);	

if($this->inv[0]->retm_stetus == 1 && $this->inv[0]->retm_proceed == 0){$type = "PENDING";}else if($this->inv[0]->retm_stetus == 0){$type = "CANCEL";}else{$type = "";}
	//$this->Cell(180 ,5,$type.' RETURN NOTE (INVOICE)',0,1,'R');//end of line
	$this->Cell(0 ,5,'INVOICE RETURN NOTE',0,1,'C');//end of line
	
	//include
	
	//set font to arial, regular, 12pt
$this->SetFont('Arial','B',10);
if(isset($this->inv[0]->sup_type)){
if($this->inv[0]->sup_type=="Foreign"){$sup = "SHIPPER"; $sref = "SHIPPER REF.No.";}else{$sup = "SUPPLIER";$sref = "SUPPLIER REF.No.";}
$repcom = strtoupper(stripslashes($this->inv[0]->sup_company));
$repcom = iconv('UTF-8', 'windows-1252', $repcom);
$repad = strtoupper(stripslashes($this->inv[0]->sup_addres));
$repad = iconv('UTF-8', 'windows-1252', $repad);

$repad1 = strtoupper(stripslashes($this->inv[0]->sup_add1));
$repad1 = iconv('UTF-8', 'windows-1252', $repad1);

$repad2 = strtoupper(stripslashes($this->inv[0]->sup_add2));
$repad2 = iconv('UTF-8', 'windows-1252', $repad2);
}else{$sup="CUSTOMER";  $repcom="N/A"; $repad=$repad1=$repad2="";}
//bill end
$this->Cell(1 ,4,$sup,0,0);//end of line
//$this->Cell(130 ,5,'[Street Address]',0,0);
$this->Cell(59 ,4,'',0,1);//end of line


$podt = date("Y-m-d", strtotime($this->inv[0]->ret_cdate));
$this->SetFont('Arial','',8);
$this->Cell(130 ,4,'',0,0);
$this->Cell(33 ,4,'DATE',0,0);
$this->Cell(34 ,4,': '.strtoupper($podt),0,1);//end of line



$po="N/A";
$this->Cell(130 ,4, $this->inv[0]->cust_company ,0,0);
$this->Cell(33 ,4,'RETURN NOTE No.',0,0);
$this->Cell(34 ,4,': '.$this->inv[0]->retm_code.$this->inv[0]->retm_id,0,1);//end of line

//$this->Cell(130 ,4, strtoupper($repad1)  ,0,0);
$this->Cell(130 ,4,$this->inv[0]->cust_addres,0,0);
//$this->Cell(34 ,4,': '.$this->inv[0]->grn_code.$this->inv[0]->grn_id,0,1);//end of line

//$this->Cell(130 ,4, strtoupper($repad2) ,0,0);
//$this->Cell(33 ,4,'GRN DATE.',0,0);
//$this->Cell(34 ,4,': '.strtoupper(date("d-M-Y", strtotime($this->inv[0]->grn_cdate))),0,1);//end of line

if(isset($this->inv[0]->cnty_name)){
 $this->Cell(130 ,4,strtoupper($this->inv[0]->cnty_name)  ,0,0);   
}
$this->SetFont('Arial','B',8);
$this->Cell(33 ,4,$this->inv[0]->user_fname.' '.$this->inv[0]->user_lname.' - '.$this->inv[0]->user_mobnum,0,0);
//$this->Cell(34 ,4,': '.$po,0,1);//end of line

//$this->Cell(130 ,5,strtoupper($this->inv[0]->cnty_name)  ,0,0);

//$this->Cell(160 ,4,'MES REF.No.',0,0);
//$this->Cell(40 ,4,': ',0,1);//end of line

$this->SetFont('Arial','',8);
$this->Cell(130 ,4,'' ,0,0);
$this->SetFont('Arial','',8);
$this->Cell(33 ,4,'',0,0);
//$this->Cell(40 ,4,': ',0,1);//end of line


	
	//end include

//set font to arial, regular, 12pt
$this->SetFont('Arial','B',10);



//bill end
//$this->Cell(1 ,4,$sup,0,0);//end of line
//$this->Cell(130 ,5,'[Street Address]',0,0);
$this->Cell(59 ,4,'',0,1);//end of line


//$repad = strtoupper(stripslashes($this->inv[0]->sup_addres));
//$repad = iconv('UTF-8', 'windows-1252', $repad);

//$repad1 = strtoupper(stripslashes($this->inv[0]->sup_add1));
//$repad1 = iconv('UTF-8', 'windows-1252', $repad1);

//$repad2 = strtoupper(stripslashes($this->inv[0]->sup_add2));
//$repad2 = iconv('UTF-8', 'windows-1252', $repad2);


//make a dummy empty cell as a vertical spacer
//$this->Cell(40 ,10,'',0,1);//end of line

$this->Ln(8);
		
		$h = 5;
		$left = 40;
		$top = 10;	
		#tableheader
		$this->SetFillColor(200,200,200);	
		$left = $this->GetX();
		$this->SetFont("Arial", "B", 8);
		$this->Cell(10,$h,'ID',1,0,'C',true);
		$this->SetX($left += 10); $this->Cell(25, $h, 'INVOICE', 1, 0, 'C',true);
		$this->SetX($left += 25); $this->Cell(78, $h, 'DESCRIPTION', 1, 0, 'C',true);
		//$this->SetX($left += 118); $this->Cell(15, $h, 'UNIT', 1, 0, 'C',true);
		$this->SetX($left += 78); $this->Cell(12, $h, 'QTY', 1, 0, 'C',true);		
		$this->SetX($left += 12); $this->Cell(10, $h, 'FREE', 1, 0, 'C',true);		
		
	$this->SetX($left += 10); $this->Cell(25, $h, 'RATE(LKR)', 1, 0, 'C',true);
	$this->SetX($left += 25); $this->Cell(25, $h, 'AMOUNT(LKR)', 1, 1, 'C',true);

		//$this->Ln(20);
		
		$this->SetFont('Arial','',10);
		$this->SetWidths(array(10,25,78,12,10,25,25));
		$this->SetAligns(array('C','L','L','R','R','R','R'));
		//$this->SetFontStyle(array('B','B','B','B','B','B','B','B'));
		$no = 1; $this->SetFillColor(255);

		$i=0;
        $total=0;
        $itmcount=0;
        
        foreach ($this->inv_itm as $post)   { 
            //if($post->serv_name!=""){$itm_name = $post->serv_name;
            //}else{$itm_name = $post->brand_name." ".$post->itm_name.$post->serv_name."\n".$post->part_no."\n".$post->model_name;}
            
            $this->Row(

            array($no++,
            $post[0],
			$post[1]."-".$post[2],
            $post[4], 
			$post[6], 
			
		    number_format(($post[5]),2,".",","),                                                                                        
            number_format(($post[4] * $post[5]),2,".",",")
          ));
          
          $i= $i+1;
      $total = $total + ($post[4]* $post[5]) ;
       //$total = number_format(($totalold),2,".",",");
          $itmcount = $itmcount+$post[4];
        }
        
        $this->Ln(5);
//summary
if($this->inv[0]->po_discount>0.00){  
    $dis_val = ($total/100)*$this->inv[0]->po_discount;
    $this->Cell(92 ,5,'',0,0);
    $this->Cell(38 ,5,'DISCOUNT '.$this->inv[0]->po_discount.'%',0,0);
    $this->Cell(28 ,5,'LKR',1,0);
    $this->Cell(28 ,5,number_format($dis_val,2),1,1,'R');//end of line
    $total = $total - $dis_val;
}


$this->Cell(92 ,5,'',0,0);
$this->Cell(38 ,5,'SUB TOTAL',0,0);
$this->Cell(28 ,5,'LKR',1,0);
$this->Cell(28 ,5,number_format($total,2),1,1,'R');//end of line

//$dd = ($this->inv[0]->po_discount * 100)/$total;
//$dispre = number_format((float)$dd, 2, '.', '');

$this->Cell(92 ,5,'',0,0);
//$this->Cell(38 ,5,'DISCOUNT '.$dispre.'%',0,0);
//$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
//$this->Cell(28 ,5,number_format($this->inv[0]->po_discount,2),1,1,'R');//end of line
//$this->Cell(32 ,5,$post->discount.'%'.number_format($post->dis_price,2),1,1,'R');//end of line
//$divd = ($total-($this->inv[0]->po_discount));

//$this->Cell(92 ,5,'',0,0);
//$this->Cell(38 ,5,'NET TOTAL',0,0);
//$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
//$this->Cell(28 ,5,number_format($total-$this->inv[0]->po_discount,2),1,1,'R');//end of line
//$this->Cell(32 ,5,$post->discount.'%'.number_format($post->dis_price,2),1,1,'R');//end of line

//$divd = ($total-($this->inv[0]->po_discount));

//$taxspre = ($this->inv[0]->po_tax * $divd)/100 ;






//$this->Cell(92 ,5,'',0,0);
//$this->Cell(38 ,5,'TOTAL',0,0);
//$this->Cell(28 ,5,$this->inv[0]->curr_symble,1,0);
//$this->Cell(28 ,5,number_format($this->inv[0]->po_final_tot,2),1,1,'R');//end of line

$this->Ln(2);
$this->SetFont('Arial','B',8);
$this->Cell(12 ,5,'ITEMS: ',0,0);//end of line
//$this->Cell(130 ,5,'[Street Address]',0,0);
$this->SetFont('Arial','',8);
$this->Cell(10 ,5,$i,0,0);//end of line
$this->SetFont('Arial','B',8);
$this->Cell(19 ,5,'QUANTITY: ',0,0);//end of line
$this->SetFont('Arial','',8);
$this->Cell(10 ,5,$itmcount,0,1);//end of line
//$this->AliasNbPages();
//$this->AddPage();

$this->Ln(2);
$this->SetFont('Arial','B',8);
$this->Cell(30 ,5,'RETURN REASON :',0,0);
$this->SetFont('Arial','',8);
$this->Cell(150 ,5,$this->inv[0]->reasonreturn,0,1);
//end of line

//$this->Ln(3);
//$this->SetFont('Arial','',8);

//$this->Cell(150 ,5,'---------------------',0,0);//end of line
//$this->Cell(130 ,5,'[Street Address]',0,0);
//$this->Cell(30 ,5,'----------------------',0,1);//end of line
//$this->SetFont('Arial','B',8);
//$this->Cell(50 ,5,'TERMS & CONDITIONS :',0,1);//end of line
//$this->SetFont('Arial','',10);
//$this->Cell(150 ,5,"",0,0);//end of line



//$this->inv[0]->po_tc;
$this->SetFont('Arial','',9);
$this->Ln(15);
$this->Cell(80 ,5,'',0,0);//end of line
$this->Cell(70 ,5,'-------------------------',0,0);//end of line
$this->Cell(40 ,5,'-------------------------',0,1);//end of line

$this->Cell(80 ,2,'',0,0);//end of line
$this->Cell(70 ,2,'     Requested by',0,0);//end of line
$this->Cell(40 ,2,'    Authorized By',0,1);//end of line


//$this->Ln(5);
$this->SetFont('Arial','',8);


	}

	public function printPDF () {
				
	
		
	    $this->SetAutoPageBreak(false);
	    $this->AliasNbPages();
	    $this->SetFont("helvetica", "B", 10);
	    //$this->AddPage();
		
		
		
		
		
	    $this->rptDetailData();
			    
	    $this->Output();
  	}
  	
  	private $widths;
	private $aligns;

	function SetWidths($w)
	{
		//Set the array of column widths
		$this->widths=$w;
	}

	function SetAligns($a)
	{
		//Set the array of column alignments
		$this->aligns=$a;
	}

	function Row($data)
	{
		//Calculate the height of the row
		$nb=0;
		for($i=0;$i<count($data);$i++)
			$nb=max($nb,$this->NbLines($this->widths[$i],$data[$i]));
		$h=4*$nb;
		//Issue a page break first if needed
		$this->CheckPageBreak($h);
		//Draw the cells of the row
		for($i=0;$i<count($data);$i++)
		{
			$w=$this->widths[$i];
			$a=isset($this->aligns[$i]) ? $this->aligns[$i] : 'L';
			//Save the current position
			$x=$this->GetX();
			$y=$this->GetY();
			//Draw the border
			$this->Rect($x,$y,$w,$h);
			//Print the text
			$this->MultiCell($w,4,$data[$i],0,$a);
			//Put the position to the right of the cell
			$this->SetXY($x+$w,$y);
		}
		//Go to the next line
		$this->Ln($h);
	}

	function CheckPageBreak($h)
	{
		//If the height h would cause an overflow, add a new page immediately
		if($this->GetY()+$h>$this->PageBreakTrigger)
			
			$this->AddPage($this->CurOrientation);
	
	}

	function NbLines($w,$txt)
	{
		//Computes the number of lines a MultiCell of width w will take
		$cw=&$this->CurrentFont['cw'];
		if($w==0)
			$w=$this->w-$this->rMargin-$this->x;
		$wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
		$s=str_replace("\r",'',$txt);
		$nb=strlen($s);
		if($nb>0 and $s[$nb-1]=="\n")
			$nb--;
		$sep=-1;
		$i=0;
		$j=0;
		$l=0;
		$nl=1;
		while($i<$nb)
		{
			$c=$s[$i];
			if($c=="\n")
			{
				$i++;
				$sep=-1;
				$j=$i;
				$l=0;
				$nl++;
				continue;
			}
			if($c==' ')
				$sep=$i;
			$l+=$cw[$c];
			if($l>$wmax)
			{
				if($sep==-1)
				{
					if($i==$j)
						$i++;
				}
				else
					$i=$sep+1;
				$sep=-1;
				$j=$i;
				$l=0;
				$nl++;
			}
			else
				$i++;
		}
		return $nl;
	}
} //end of class


$options = array(
	'inv' => $inv, //nama file penyimpanan, kosongkan jika output ke browser
	'destinationfile' => '', //I=inline browser (default), F=local file, D=download
	'paper_size'=>'F4',	//paper size: F4, A3, A4, A5, Letter, Legal
	'orientation'=>'P' //orientation: P=portrait, L=landscape

);

$tabel = new PDF_sample($data, $options,$inv,$inv_itm,$tm);
//$tabel->printPDF();
$tabel->printPDF();
?>